package org.apache.maven.deploy.deployers;

/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2001 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" and
 *    "Apache MavenSession" must not be used to endorse or promote products
 *    derived from this software without prior written permission. For
 *    written permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    "Apache MavenSession", nor may "Apache" appear in their name, without
 *    prior written permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * ====================================================================
 */
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintWriter;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.net.ProtocolCommandEvent;
import org.apache.commons.net.ProtocolCommandListener;
import org.apache.commons.net.ftp.FTP;
import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPReply;
import org.apache.maven.deploy.RepositoryInfo;
import org.apache.maven.deploy.DeployRequest;
import org.apache.maven.deploy.exceptions.AuthenticationException;
import org.apache.maven.deploy.exceptions.TransferFailedException;

/**
 * An FTP deployer based on the FTPClient in the Commons Net package.
 *
 * Proxy server for FTPClient is not supported:
 * {@link http://nagoya.apache.org/bugzilla/show_bug.cgi?id=18039}
 * 
 * @author <a href="mailto:jason@zenplex.com">Jason van Zyl</a>
 * @author <a href="michal.maczka@dimatics.com">Michal Maczka</a>
 * @version $Id: FtpDeployer.java,v 1.7 2003/07/17 11:13:17 michal Exp $
 * 
 * @todo review exception handling
 * 
 * 
 */
public class FtpDeployer extends AbstractDeployer
{
    /** Protocol understandable by this deployer*/
    public final static String PROTOCOL = "ftp://";

    private FTPClient ftp = null;

    /* (non-Javadoc)
     * @see org.apache.maven.deploy.deployers.Deployer#init(org.apache.maven.deploy.HostInfo)
     */
    public void init(RepositoryInfo repoInfo)
        throws AuthenticationException
    {
        String username = repoInfo.getUserName();
        String password = repoInfo.getPassword();
        String host = repoInfo.getHost();

        ftp = new FTPClient();

        if (repoInfo.isDebugOn())
        {
            ftp.addProtocolCommandListener(
                new PrintCommandListener(new PrintWriter(System.out)));
        }
        try
        {
            int reply;
            if (repoInfo.getPort()
                != RepositoryInfo.UNKNOWN_PORT)
            {
                ftp.connect(host, repoInfo.getPort());
            }
            else
            {
                ftp.connect(host);
            }
            System.out.println("Connected to " + host + ".");

            // After connection attempt, you should check the reply code to verify
            // success.
            reply = ftp.getReplyCode();

            if (FTPReply.isPositiveCompletion(reply) == false)
            {
                ftp.disconnect();
                System.err.println();
                throw new AuthenticationException("FTP server refused connection.");
            }
        }
        catch (IOException e)
        {
            if (ftp.isConnected())
            {
                try
                {
                    ftp.disconnect();
                }
                catch (IOException f)
                {
                    // do nothing
                }
            }
            throw new AuthenticationException("Could not connect to server.");
        }

        try
        {
            if (ftp.login(username.trim(), password.trim()) == false)
            {
                throw new AuthenticationException("Cannot login to remote system");
            }

            System.out.println("Remote system is " + ftp.getSystemName());

            // Set to binary mode.
            ftp.setFileType(FTP.BINARY_FILE_TYPE);
            // Use passive mode as default because most of us are
            // behind firewalls these days.
            ftp.enterLocalPassiveMode();
            ftp.changeWorkingDirectory(repoInfo.getBasedir());

        }
        catch (IOException e)
        {
            throw new AuthenticationException("Cannot login to remote system");
        }

    }

    /* (non-Javadoc)
     * @see org.apache.maven.deploy.deployers.Deployer#release()
     */
    public void release()
    {
        if (ftp.isConnected())
        {
            try
            {
                ftp.disconnect();
            }
            catch (IOException e)
            {
                // do nothing
            }
        }

    }

    /**
     * @see Deployer#deploy(DeployRequest)
     */
    public void deploy(DeployRequest request) throws TransferFailedException
    {

        try
        {
            String[] dirs = StringUtils.split(request.dirname(), "/");
            for (int i = 0; i < dirs.length; i++)
            {
                ftp.makeDirectory(dirs[i]);
                ftp.changeWorkingDirectory(dirs[i]);
            }
            ftp.storeFile(
                request.filename(),
                new FileInputStream(request.getSrcFile()));
            for (int i = 0; i < dirs.length; i++)
            {
               ftp.changeWorkingDirectory("..");
            }

        }
        catch (Exception e)
        {
            e.printStackTrace();
            throw new TransferFailedException(e.getMessage());
        }

    }

    /**
     * Description of the Class
     */
    public class PrintCommandListener implements ProtocolCommandListener
    {
        private PrintWriter writer;

        /**
         * Constructor for the PrintCommandListener object
         *
         * @param writer
         */
        public PrintCommandListener(PrintWriter writer)
        {
            this.writer = writer;
        }

        /**
         * Description of the Method
         */
        public void protocolCommandSent(ProtocolCommandEvent event)
        {
            writer.print(event.getMessage());
            writer.flush();
        }

        /**
         * Description of the Method
         */
        public void protocolReplyReceived(ProtocolCommandEvent event)
        {
            writer.print(event.getMessage());
            writer.flush();
        }
    }

}
